Index: trunk/NEMO/OPA_SRC/ZDF/zdftke.F90
===================================================================
--- trunk/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 1531)
+++ trunk/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 1532)
@@ -384,317 +572,47 @@
                zsqen = SQRT( en(ji,jj,jk) )
                zav   = rn_ediff * zmxlm(ji,jj,jk) * zsqen
+               avm  (ji,jj,jk) = MAX( zav,                  avmb(jk) ) * tmask(ji,jj,jk)
                avt  (ji,jj,jk) = MAX( zav, avtb_2d(ji,jj) * avtb(jk) ) * tmask(ji,jj,jk)
-               zmxlm(ji,jj,jk) = MAX( zav, avmb(jk) ) * tmask(ji,jj,jk)
-               zmxld(ji,jj,jk) = zsqen / zmxld(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-
-      ! 2. Surface boundary condition on tke and its eddy viscosity (zmxlm)
-      ! -------------------------------------------------
-      ! en(1)   = rn_ebb sqrt(utau^2+vtau^2) / rau0  (min value rn_emin0)
-      ! zmxlm(1) = avmb(1) and zmxlm(jpk) = 0.
-!CDIR NOVERRCHK
-      DO jj = 2, jpjm1
-!CDIR NOVERRCHK
-         DO ji = fs_2, fs_jpim1   ! vector opt.
-            ztx2 = utau(ji-1,jj  ) + utau(ji,jj)
-            zty2 = vtau(ji  ,jj-1) + vtau(ji,jj)
-            zesurf = zbbrau * SQRT( ztx2 * ztx2 + zty2 * zty2 )
-            en (ji,jj,1) = MAX( zesurf, rn_emin0 ) * tmask(ji,jj,1)
-            zav  =  rn_ediff * zmxlm(ji,jj,1) * SQRT( en(ji,jj,1) )
-            zmxlm(ji,jj,1  ) = MAX( zav, avmb(1)                  ) * tmask(ji,jj,1)
-            avt  (ji,jj,1  ) = MAX( zav, avtb(1) * avtb_2d(ji,jj) ) * tmask(ji,jj,1)
-            zmxlm(ji,jj,jpk) = 0.e0
-         END DO
-      END DO
-
-      ! 3. Now Turbulent kinetic energy (output in en)
-      ! -------------------------------
-      ! Resolution of a tridiagonal linear system by a "methode de chasse"
-      ! computation from level 2 to jpkm1  (e(1) already computed and e(jpk)=0 ). 
-
-      SELECT CASE ( nn_pdl )
-      !
-      CASE ( 0 )           ! No Prandtl number
+               dissl(ji,jj,jk) = zsqen / zmxld(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      CALL lbc_lnk( avm, 'W', 1. )      ! Lateral boundary conditions (sign unchanged)
+      !
+      DO jk = 2, jpkm1            !* vertical eddy viscosity at u- and v-points
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               avmu(ji,jj,jk) = 0.5 * ( avm(ji,jj,jk) + avm(ji+1,jj  ,jk) ) * umask(ji,jj,jk)
+               avmv(ji,jj,jk) = 0.5 * ( avm(ji,jj,jk) + avm(ji  ,jj+1,jk) ) * vmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      CALL lbc_lnk( avmu, 'U', 1. )   ;   CALL lbc_lnk( avmv, 'V', 1. )      ! Lateral boundary conditions
+      !
+      IF( nn_pdl == 1 ) THEN      !* Prandtl number case: update avt
          DO jk = 2, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
-                  !                                                             ! shear prod. - stratif. destruction
-                  zcoef = 0.5 / fse3w(ji,jj,jk)
-                  zdku = zcoef * (  ub(ji-1, jj ,jk-1) + ub(ji,jj,jk-1)   &          ! shear
-                     &            - ub(ji-1, jj ,jk  ) - ub(ji,jj,jk  )  )
-                  zdkv = zcoef * (  vb( ji ,jj-1,jk-1) + vb(ji,jj,jk-1)   &
-                     &            - vb( ji ,jj-1,jk  ) - vb(ji,jj,jk  )  )
-                  zesh2 =  eboost * ( zdku*zdku + zdkv*zdkv ) - rn2b(ji,jj,jk)        ! coefficient (zesh2)
-                  !
-                  !                                                             ! Matrix
-                  zcof = zfact1 * tmask(ji,jj,jk)
-                  !                                                                  ! lower diagonal
-                  avmv(ji,jj,jk) = zcof * ( zmxlm(ji,jj,jk  ) + zmxlm(ji,jj,jk-1) )   &
-                     &                  / ( fse3t(ji,jj,jk-1) * fse3w(ji,jj,jk  ) )
-                  !                                                                  ! upper diagonal
-                  avmu(ji,jj,jk) = zcof * ( zmxlm(ji,jj,jk+1) + zmxlm(ji,jj,jk  ) )   &
-                     &                  / ( fse3t(ji,jj,jk  ) * fse3w(ji,jj,jk) )
-                  !                                                                  ! diagonal
-                  zwd(ji,jj,jk) = 1. - avmv(ji,jj,jk) - avmu(ji,jj,jk) + zfact2 * zmxld(ji,jj,jk)
-                  !
-                  !                                                             ! right hand side in en 
-                  IF( .NOT. ln_lc ) THEN                                             ! No Langmuir cells
-                     en(ji,jj,jk) = en(ji,jj,jk) + zfact3 * zmxld (ji,jj,jk) * en(ji,jj,jk)   &
-                        &                        +   rdt  * zmxlm (ji,jj,jk) * zesh2
-                  ELSE                                                               ! Langmuir cell source term
-                     en(ji,jj,jk) = en(ji,jj,jk) + zfact3 * zmxld (ji,jj,jk) * en(ji,jj,jk)   &
-                        &                        +   rdt  * zmxlm (ji,jj,jk) * zesh2          &
-                        &                        +   rdt  * ztkelc(ji,jj,jk)
-                  ENDIF
-               END DO
-            END DO
-         END DO
-         !
-      CASE ( 1 )           ! Prandtl number
-         DO jk = 2, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  !                                                             ! shear prod. - stratif. destruction
-                  zcoef = 0.5 / fse3w(ji,jj,jk)                                     
-                  zdku = zcoef * (  ub(ji-1,jj  ,jk-1) + ub(ji,jj,jk-1)   &          ! shear
-                  &               - ub(ji-1,jj  ,jk  ) - ub(ji,jj,jk  )  )
-                  zdkv = zcoef * (  vb(ji  ,jj-1,jk-1) + vb(ji,jj,jk-1)   &
-                  &               - vb(ji  ,jj-1,jk  ) - vb(ji,jj,jk  )  )
-                  zsh2 = zdku * zdku + zdkv * zdkv                                   ! square of shear
-                  zri  = MAX( rn2b(ji,jj,jk), 0. ) / ( zsh2 + 1.e-20 )                ! local Richardson number
+                  zcoef = 0.5 / ( fse3w(ji,jj,jk) * fse3w(ji,jj,jk) )
+                  !                                          ! shear
+                  zdku = avmu(ji-1,jj,jk) * ( un(ji-1,jj,jk-1) - un(ji-1,jj,jk) ) * ( ub(ji-1,jj,jk-1) - ub(ji-1,jj,jk) )   &
+                    &  + avmu(ji  ,jj,jk) * ( un(ji  ,jj,jk-1) - un(ji  ,jj,jk) ) * ( ub(ji  ,jj,jk-1) - ub(ji  ,jj,jk) )
+                  zdkv = avmv(ji,jj-1,jk) * ( vn(ji,jj-1,jk-1) - vn(ji,jj-1,jk) ) * ( vb(ji,jj-1,jk-1) - vb(ji,jj-1,jk) )   &
+                    &  + avmv(ji,jj  ,jk) * ( vn(ji,jj  ,jk-1) - vn(ji,jj  ,jk) ) * ( vb(ji,jj  ,jk-1) - vb(ji,jj  ,jk) )
+                  !                                          ! local Richardson number
+                  zri   = MAX( rn2b(ji,jj,jk), 0. ) * avm(ji,jj,jk) / (zcoef * (zdku + zdkv + rn_bshear ) )
+                  zpdlr = MAX(  0.1,  0.2 / MAX( 0.2 , zri )  )
+!!gm and even better with the use of the "true" ri_crit=0.22222...  (this change the results!)
+!!gm              zpdlr = MAX(  0.1,  ri_crit / MAX( ri_crit , zri )  )
+                  avt(ji,jj,jk)   = MAX( zpdlr * avt(ji,jj,jk), avtb_2d(ji,jj) * avtb(jk) ) * tmask(ji,jj,jk)
 # if defined key_c1d
-                  e_ric(ji,jj,jk) = zri * tmask(ji,jj,jk)                            ! c1d config. : save Ri 
+                  e_pdl(ji,jj,jk) = zpdlr * tmask(ji,jj,jk)    ! c1d configuration : save masked Prandlt number
+                  e_ric(ji,jj,jk) = zri * tmask(ji,jj,jk)                            ! c1d config. : save Ri
 # endif
-                  zpdl = 1.0                                                         ! Prandtl number
-                  IF( zri >= 0.2 )   zpdl = 0.2 / zri
-                  zpdl = MAX( 0.1, zpdl )
-                  zesh2 = eboost * zsh2 - zpdl * rn2b(ji,jj,jk)                       ! coefficient (esh2)
-                  !
-                  !                                                             ! Matrix
-                  zcof = zfact1 * tmask(ji,jj,jk)
-                  !                                                                 ! lower diagonal
-                  avmv(ji,jj,jk) = zcof * ( zmxlm(ji,jj,jk  ) + zmxlm(ji,jj,jk-1) )   &
-                  &                     / ( fse3t(ji,jj,jk-1) * fse3w(ji,jj,jk  ) )
-                  !                                                                 ! upper diagonal
-                  avmu(ji,jj,jk) = zcof * ( zmxlm(ji,jj,jk+1) + zmxlm(ji,jj,jk  ) )   &
-                  &                     / ( fse3t(ji,jj,jk  ) * fse3w(ji,jj,jk) )
-                  !                                                                 ! diagonal
-                  zwd(ji,jj,jk) = 1. - avmv(ji,jj,jk) - avmu(ji,jj,jk) + zfact2 * zmxld(ji,jj,jk)
-                  !
-                  !                                                             ! right hand side in en 
-                  IF( .NOT. ln_lc ) THEN                                             ! No Langmuir cells
-                     en(ji,jj,jk) = en(ji,jj,jk) + zfact3 * zmxld (ji,jj,jk) * en   (ji,jj,jk)   &
-                        &                        +   rdt  * zmxlm (ji,jj,jk) * zesh2
-                  ELSE                                                               ! Langmuir cell source term
-                     en(ji,jj,jk) = en(ji,jj,jk) + zfact3 * zmxld (ji,jj,jk) * en   (ji,jj,jk)   &
-                        &                        +   rdt  * zmxlm (ji,jj,jk) * zesh2             &
-                        &                        +   rdt  * ztkelc(ji,jj,jk)
-                  ENDIF
-                  zmxld(ji,jj,jk) = zpdl * tmask(ji,jj,jk)                      ! store masked Prandlt number in zmxld array
-               END DO
-            END DO
-         END DO
-         !
-      END SELECT
-
-# if defined key_c1d
-      e_pdl(:,:,2:jpkm1) = zmxld(:,:,2:jpkm1)      ! c1d configuration : save masked Prandlt number
-      e_pdl(:,:,      1) = e_pdl(:,:,      2)
-      e_pdl(:,:,    jpk) = e_pdl(:,:,  jpkm1)      
-# endif
-
-      ! 4. Matrix inversion from level 2 (tke prescribed at level 1)
-      !!--------------------------------
-      DO jk = 3, jpkm1                             ! First recurrence : Dk = Dk - Lk * Uk-1 / Dk-1
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1    ! vector opt.
-               zwd(ji,jj,jk) = zwd(ji,jj,jk) - avmv(ji,jj,jk) * avmu(ji,jj,jk-1) / zwd(ji,jj,jk-1)
-            END DO
-         END DO
-      END DO
-      DO jj = 2, jpjm1                             ! Second recurrence : Lk = RHSk - Lk / Dk-1 * Lk-1
-         DO ji = fs_2, fs_jpim1    ! vector opt.
-            avmv(ji,jj,2) = en(ji,jj,2) - avmv(ji,jj,2) * en(ji,jj,1)    ! Surface boudary conditions on tke
-         END DO
-      END DO
-      DO jk = 3, jpkm1
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1    ! vector opt.
-               avmv(ji,jj,jk) = en(ji,jj,jk) - avmv(ji,jj,jk) / zwd(ji,jj,jk-1) *avmv(ji,jj,jk-1)
-            END DO
-         END DO
-      END DO
-      DO jj = 2, jpjm1                             ! thrid recurrence : Ek = ( Lk - Uk * Ek+1 ) / Dk
-         DO ji = fs_2, fs_jpim1    ! vector opt.
-            en(ji,jj,jpkm1) = avmv(ji,jj,jpkm1) / zwd(ji,jj,jpkm1)
-         END DO
-      END DO
-      DO jk = jpk-2, 2, -1
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1    ! vector opt.
-               en(ji,jj,jk) = ( avmv(ji,jj,jk) - avmu(ji,jj,jk) * en(ji,jj,jk+1) ) / zwd(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-      DO jk = 2, jpkm1                             ! set the minimum value of tke
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               en(ji,jj,jk) = MAX( en(ji,jj,jk), rn_emin ) * tmask(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-     
-      ! 5. Add extra TKE due to surface and internal wave breaking (nn_etau /= 0)
-      !!----------------------------------------------------------
-      IF( nn_etau /= 0 ) THEN        ! extra tke : en = en + rn_efr * en(1) * exp( -z/zhtau )
-         !
-         SELECT CASE( nn_htau )           ! Choice of the depth of penetration
-         CASE( 0 )                                    ! constant depth penetration (here 10 meters)
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zhtau(ji,jj) = 10.
-               END DO
-            END DO
-         CASE( 1 )                                    ! meridional profile  1
-            DO jj = 2, jpjm1                          ! ( 5m in the tropics to a maximum of 40 m at high lat.)
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zhtau(ji,jj) = MAX( 5., MIN( 40., 60.*ABS( SIN( rpi/180. * gphit(ji,jj) ) ) )   )
-               END DO
-            END DO
-         CASE( 2 )                                    ! meridional profile 2
-            DO jj = 2, jpjm1                          ! ( 5m in the tropics to a maximum of 60 m at high lat.)
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zhtau(ji,jj) =  MAX( 5.,6./4.* MIN( 40., 60.*ABS( SIN( rpi/180. * gphit(ji,jj) ) ) )   )
-               END DO
-            END DO
-         END SELECT
-         ! 
-         IF( nn_etau == 1 ) THEN          ! extra term throughout the water column
-            DO jk = 2, jpkm1
-               DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
-                     en(ji,jj,jk) = en(ji,jj,jk)   &
-                        &         + rn_efr * en(ji,jj,1)*EXP( -fsdepw(ji,jj,jk) / zhtau(ji,jj) ) &
-                        &                  * ( 1.e0 - fr_i(ji,jj) )  * tmask(ji,jj,jk)
-                  END DO
-               END DO
-            END DO
-         ELSEIF( nn_etau == 2 ) THEN      ! extra term only at the base of the mixed layer
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  jk = nmln(ji,jj)
-                  en(ji,jj,jk) = en(ji,jj,jk)    &
-                     &         + rn_efr * en(ji,jj,1)*EXP( -fsdepw(ji,jj,jk) / zhtau(ji,jj) ) &
-                     &                   * ( 1.e0 - fr_i(ji,jj) )  * tmask(ji,jj,jk)
-               END DO
-            END DO
-         ENDIF
-         !
+              END DO
+            END DO
+         END DO
       ENDIF
-
-
-      ! Lateral boundary conditions (sign unchanged)
-      CALL lbc_lnk( en, 'W', 1. )   ;   CALL lbc_lnk( avt, 'W', 1. )
-
-
-      !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-      ! IV.  Before vertical eddy vicosity and diffusivity coefficients
-      !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-      !
-      SELECT CASE ( nn_ave )
-      CASE ( 0 )                                     ! no horizontal average 
-         DO jk = 2, jpkm1                                 ! only vertical eddy viscosity 
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  avmu(ji,jj,jk) = ( avt  (ji,jj,jk) + avt  (ji+1,jj  ,jk) ) * umask(ji,jj,jk)   &
-                  &     / MAX( 1.,   tmask(ji,jj,jk) + tmask(ji+1,jj  ,jk) )
-                  avmv(ji,jj,jk) = ( avt  (ji,jj,jk) + avt  (ji  ,jj+1,jk) ) * vmask(ji,jj,jk)   &
-                  &     / MAX( 1.,   tmask(ji,jj,jk) + tmask(ji  ,jj+1,jk) )
-               END DO
-            END DO
-         END DO
-         CALL lbc_lnk( avmu, 'U', 1. )   ;   CALL lbc_lnk( avmv, 'V', 1. )      ! Lateral boundary conditions
-         !
-      CASE ( 1 )                                     ! horizontal average                         ( 1/2  1/2 )
-         !                                                ! Vertical eddy viscosity    avmu = 1/4 ( 1    1   )
-         !                                                !                                       ( 1/2  1/2 )
-         !                                                !
-         !                                                !                                       ( 1/2  1   1/2 )            
-         !                                                !                            avmv = 1/4 ( 1/2  1   1/2 )      
-         DO jk = 2, jpkm1                                
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-# if defined key_vectopt_memory
-                  !                                       ! caution : vectopt_memory change the solution
-                  !                                       !           (last digit of the solver stat)
-                  avmu(ji,jj,jk) = (      avt(ji,jj  ,jk) + avt(ji+1,jj  ,jk)   &
-                     &              +.5*( avt(ji,jj-1,jk) + avt(ji+1,jj-1,jk)   &
-                     &                   +avt(ji,jj+1,jk) + avt(ji+1,jj+1,jk) ) ) * eumean(ji,jj,jk)
-
-                  avmv(ji,jj,jk) = (      avt(ji  ,jj,jk) + avt(ji  ,jj+1,jk)   &
-                     &              +.5*( avt(ji-1,jj,jk) + avt(ji-1,jj+1,jk)   &
-                     &                   +avt(ji+1,jj,jk) + avt(ji+1,jj+1,jk) ) ) * evmean(ji,jj,jk)
-# else
-                  avmu(ji,jj,jk) = (   avt  (ji,jj  ,jk) + avt  (ji+1,jj  ,jk)   &
-                     &           +.5*( avt  (ji,jj-1,jk) + avt  (ji+1,jj-1,jk)   &
-                     &                +avt  (ji,jj+1,jk) + avt  (ji+1,jj+1,jk) ) ) * umask(ji,jj,jk)   &
-                     &    / MAX( 1.,   tmask(ji,jj  ,jk) + tmask(ji+1,jj  ,jk)   &
-                     &           +.5*( tmask(ji,jj-1,jk) + tmask(ji+1,jj-1,jk)   &
-                     &                +tmask(ji,jj+1,jk) + tmask(ji+1,jj+1,jk) )  )
-
-                  avmv(ji,jj,jk) = (   avt  (ji  ,jj,jk) + avt  (ji  ,jj+1,jk)   &
-                     &           +.5*( avt  (ji-1,jj,jk) + avt  (ji-1,jj+1,jk)   &
-                     &                +avt  (ji+1,jj,jk) + avt  (ji+1,jj+1,jk) ) ) * vmask(ji,jj,jk)   &
-                     &   /  MAX( 1.,   tmask(ji  ,jj,jk) + tmask(ji  ,jj+1,jk)   &
-                     &           +.5*( tmask(ji-1,jj,jk) + tmask(ji-1,jj+1,jk)   &
-                     &                +tmask(ji+1,jj,jk) + tmask(ji+1,jj+1,jk) )  )
-# endif
-               END DO
-            END DO
-         END DO
-         CALL lbc_lnk( avmu, 'U', 1. )   ;   CALL lbc_lnk( avmv, 'V', 1. )      ! Lateral boundary conditions 
-         !
-         !                                                ! Vertical eddy diffusivity             (1 2 1)
-         !                                                !                            avt = 1/16 (2 4 2)
-         !                                                !                                       (1 2 1)
-         DO jk = 2, jpkm1         
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-#  if defined key_vectopt_memory
-                  avt(ji,jj,jk) = ( avmu(ji,jj,jk) + avmu(ji-1,jj  ,jk)                          &
-                     &            + avmv(ji,jj,jk) + avmv(ji  ,jj-1,jk)  ) * etmean(ji,jj,jk)
-#  else
-                  avt(ji,jj,jk) = ( avmu (ji,jj,jk) + avmu (ji-1,jj  ,jk)                        &
-                     &            + avmv (ji,jj,jk) + avmv (ji  ,jj-1,jk)  ) * tmask(ji,jj,jk)   &
-                     &  / MAX( 1.,  umask(ji,jj,jk) + umask(ji-1,jj  ,jk)                        &
-                     &            + vmask(ji,jj,jk) + vmask(ji  ,jj-1,jk)  )
-#  endif
-               END DO
-            END DO
-         END DO
-         !
-      END SELECT
-      !
-      IF( nn_pdl == 1 ) THEN                            ! Ponderation by the Prandtl number (nn_pdl=1)
-         DO jk = 2, jpkm1 
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zpdl = zmxld(ji,jj,jk)
-                  avt(ji,jj,jk) = MAX( zpdl * avt(ji,jj,jk), avtb_2d(ji,jj) * avtb(jk) ) * tmask(ji,jj,jk)
-               END DO
-            END DO
-         END DO
-      ENDIF
-      !
-      DO jk = 2, jpkm1                                  ! Minimum value on the eddy viscosity
-         avmu(:,:,jk) = MAX( avmu(:,:,jk), avmb(jk) ) * umask(:,:,jk)
-         avmv(:,:,jk) = MAX( avmv(:,:,jk), avmb(jk) ) * vmask(:,:,jk)
-      END DO
-
       CALL lbc_lnk( avt, 'W', 1. )                      ! Lateral boundary conditions on avt  (sign unchanged)
-
-      IF( lrst_oce )   CALL tke_rst( kt, 'WRITE' )      ! write en in restart file
 
       IF(ln_ctl) THEN
@@ -704,30 +622,22 @@
       ENDIF
       !
-   END SUBROUTINE zdf_tke_old
-
-
-   SUBROUTINE zdf_tke_init
+   END SUBROUTINE tke_avn
+
+
+   SUBROUTINE tke_init
       !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE zdf_tke_init  ***
+      !!                  ***  ROUTINE tke_init  ***
       !!                     
       !! ** Purpose :   Initialization of the vertical eddy diffivity and 
-      !!      viscosity when using a tke turbulent closure scheme
+      !!              viscosity when using a tke turbulent closure scheme
       !!
       !! ** Method  :   Read the namtke namelist and check the parameters
-      !!      called at the first timestep (nit000)
+      !!              called at the first timestep (nit000)
       !!
       !! ** input   :   Namlist namtke
       !!
       !! ** Action  :   Increase by 1 the nstop flag is setting problem encounter
-      !!
       !!----------------------------------------------------------------------
-      USE dynzdf_exp
-      USE trazdf_exp
-      !
-# if defined key_vectopt_memory
       INTEGER ::   ji, jj, jk   ! dummy loop indices
-# else
-      INTEGER ::           jk   ! dummy loop indices
-# endif
       !!
       NAMELIST/namtke/ ln_rstke, rn_ediff, rn_ediss, rn_ebb  , rn_efave, rn_emin,   &
@@ -737,23 +647,13 @@
       !!----------------------------------------------------------------------
 
-      ! Read Namelist namtke : Turbulente Kinetic Energy
-      ! --------------------
-      REWIND ( numnam )
+      REWIND ( numnam )               !* Read Namelist namtke : Turbulente Kinetic Energy
       READ   ( numnam, namtke )
-
-      ! Compute boost associated with the Richardson critic
-      !     (control values: rn_cri = 0.3   ==> eboost=1.25 for nn_pdl=1)
-      !     (                rn_cri = 0.222 ==> eboost=1.               )
-      eboost = rn_cri * ( 2. + rn_ediss / rn_ediff ) / 2.
-
-
-
-      ! Parameter control and print
-      ! ---------------------------
-      ! Control print
-      IF(lwp) THEN
+      
+      ri_cri = 2. / ( 2. + rn_ediss / rn_ediff )      ! resulting critical Richardson number
+
+      IF(lwp) THEN                    !* Control print
          WRITE(numout,*)
-         WRITE(numout,*) 'zdf_tke_init : tke turbulent closure scheme (old scheme)'
-         WRITE(numout,*) '~~~~~~~~~~~~'
+         WRITE(numout,*) 'zdf_tke : tke turbulent closure scheme - initialisation'
+         WRITE(numout,*) '~~~~~~~~'
          WRITE(numout,*) '          Namelist namtke : set tke mixing parameters'
          WRITE(numout,*) '             restart with tke from no tke              ln_rstke = ', ln_rstke
@@ -761,13 +661,8 @@
          WRITE(numout,*) '             Kolmogoroff dissipation coef.             rn_ediss = ', rn_ediss
          WRITE(numout,*) '             tke surface input coef.                   rn_ebb   = ', rn_ebb
-         WRITE(numout,*) '             tke diffusion coef.                       rn_efave = ', rn_efave
          WRITE(numout,*) '             minimum value of tke                      rn_emin  = ', rn_emin
          WRITE(numout,*) '             surface minimum value of tke              rn_emin0 = ', rn_emin0
-         WRITE(numout,*) '             number of restart iter loops              nn_itke  = ', nn_itke
          WRITE(numout,*) '             mixing length type                        nn_mxl   = ', nn_mxl
          WRITE(numout,*) '             prandl number flag                        nn_pdl   = ', nn_pdl
-         WRITE(numout,*) '             horizontal average flag                   nn_ave   = ', nn_ave
-         WRITE(numout,*) '             critic Richardson nb                      rn_cri   = ', rn_cri
-         WRITE(numout,*) '                and its associated coeff.              eboost   = ', eboost
          WRITE(numout,*) '             constant background or profile            nn_avb   = ', nn_avb
          WRITE(numout,*) '             surface mixing length = F(stress) or not  ln_mxl0  = ', ln_mxl0
@@ -781,83 +676,20 @@
          WRITE(numout,*) '             coef to compute verticla velocity of LC   rn_lc    = ', rn_lc
          WRITE(numout,*)
+         WRITE(numout,*) '             critical Richardson nb with your choice of coefs.  = ', ri_cri
       ENDIF
 
-      ! Check of some namelist values
+      !                               !* Check of some namelist values
       IF( nn_mxl  < 0    .OR. nn_mxl  > 3   )   CALL ctl_stop( 'bad flag: nn_mxl is  0, 1 or 2 ' )
       IF( nn_pdl  < 0    .OR. nn_pdl  > 1   )   CALL ctl_stop( 'bad flag: nn_pdl is  0 or 1    ' )
-      IF( nn_ave  < 0    .OR. nn_ave  > 1   )   CALL ctl_stop( 'bad flag: nn_ave is  0 or 1    ' )
       IF( nn_htau < 0    .OR. nn_htau > 2   )   CALL ctl_stop( 'bad flag: nn_htau is 0, 1 or 2 ' )
       IF( rn_lc   < 0.15 .OR. rn_lc   > 0.2 )   CALL ctl_stop( 'bad value: rn_lc must be between 0.15 and 0.2 ' )
 
-      IF( nn_etau == 2 )   CALL zdf_mxl( nit000 )      ! Initialization of nmln 
-
-      ! Horizontal average : initialization of weighting arrays 
-      ! -------------------
-      !
-      SELECT CASE ( nn_ave )
-      ! Notice: mean arrays have not to by defined at local domain boundaries due to the vertical nature of TKE
-      !
-      CASE ( 0 )                ! no horizontal average
-         IF(lwp) WRITE(numout,*) '          no horizontal average on avt, avmu, avmv'
-         IF(lwp) WRITE(numout,*) '          only in very high horizontal resolution !'
-# if defined key_vectopt_memory
-         ! caution vectopt_memory change the solution (last digit of the solver stat)
-         ! weighting mean arrays etmean, eumean and evmean
-         !           ( 1  1 )                                          ( 1 )
-         ! avt = 1/4 ( 1  1 )     avmu = 1/2 ( 1  1 )       avmv=  1/2 ( 1 )
-         !                          
-         etmean(:,:,:) = 0.e0
-         eumean(:,:,:) = 0.e0
-         evmean(:,:,:) = 0.e0
-         !
-         DO jk = 1, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  etmean(ji,jj,jk) = tmask(ji,jj,jk) / MAX( 1.,  umask(ji,jj,jk) + umask(ji-1,jj  ,jk)   &
-                  &                                            + vmask(ji,jj,jk) + vmask(ji  ,jj-1,jk) )
-                  eumean(ji,jj,jk) = umask(ji,jj,jk) / MAX( 1.,  tmask(ji,jj,jk) + tmask(ji+1,jj  ,jk) )
-                  evmean(ji,jj,jk) = vmask(ji,jj,jk) / MAX( 1.,  tmask(ji,jj,jk) + tmask(ji  ,jj+1,jk) )
-               END DO
-            END DO
-         END DO
-# endif
-         !
-      CASE ( 1 )                ! horizontal average 
-         IF(lwp) WRITE(numout,*) '          horizontal average on avt, avmu, avmv'
-# if defined key_vectopt_memory
-         ! caution vectopt_memory change the solution (last digit of the solver stat)
-         ! weighting mean arrays etmean, eumean and evmean
-         !           ( 1  1 )              ( 1/2  1/2 )             ( 1/2  1  1/2 )
-         ! avt = 1/4 ( 1  1 )   avmu = 1/4 ( 1    1   )   avmv= 1/4 ( 1/2  1  1/2 )
-         !                                 ( 1/2  1/2 )
-         etmean(:,:,:) = 0.e0
-         eumean(:,:,:) = 0.e0
-         evmean(:,:,:) = 0.e0
-         !
-         DO jk = 1, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  etmean(ji,jj,jk) = tmask(ji,jj,jk) / MAX( 1.,   umask(ji-1,jj  ,jk) + umask(ji  ,jj  ,jk)   &
-                  &                                       +       vmask(ji  ,jj-1,jk) + vmask(ji  ,jj  ,jk) )
-                  eumean(ji,jj,jk) = umask(ji,jj,jk) / MAX( 1.,   tmask(ji  ,jj  ,jk) + tmask(ji+1,jj  ,jk)   &
-                  &                                       +.5 * ( tmask(ji  ,jj-1,jk) + tmask(ji+1,jj-1,jk)   &
-                  &                                             + tmask(ji  ,jj+1,jk) + tmask(ji+1,jj+1,jk) )  )
-                  evmean(ji,jj,jk) = vmask(ji,jj,jk) / MAX( 1.,   tmask(ji  ,jj  ,jk) + tmask(ji  ,jj+1,jk)   &
-                  &                                       +.5 * ( tmask(ji-1,jj  ,jk) + tmask(ji-1,jj+1,jk)   &
-                  &                                             + tmask(ji+1,jj  ,jk) + tmask(ji+1,jj+1,jk) )  )
-               END DO
-            END DO
-         END DO
-# endif
-         !
-      END SELECT
-
-
-      ! Background eddy viscosity and diffusivity profil
-      ! ------------------------------------------------
-      IF( nn_avb == 0 ) THEN      ! Define avmb, avtb from namelist parameter
+      IF( nn_etau == 2  )   CALL zdf_mxl( nit000 )      ! Initialization of nmln 
+
+      !                               !* Background eddy viscosity and diffusivity profil
+      IF( nn_avb == 0 ) THEN                ! Define avmb, avtb from namelist parameter
          avmb(:) = avm0
          avtb(:) = avt0
-      ELSE                      ! Background profile of avt (fit a theoretical/observational profile (Krauss 1990) 
+      ELSE                                  ! Background profile of avt (fit a theoretical/observational profile (Krauss 1990) 
          avmb(:) = avm0
          avtb(:) = avt0 + ( 3.0e-4 - 2 * avt0 ) * 1.0e-4 * gdepw_0(:)   ! m2/s
@@ -865,8 +697,8 @@
       ENDIF
       !
-      !                         ! 2D shape of the avtb
-      avtb_2d(:,:) = 1.e0             ! uniform 
-      !
-      IF( nn_havtb == 1 ) THEN      ! decrease avtb in the equatorial band
+      !                                     ! 2D shape of the avtb
+      avtb_2d(:,:) = 1.e0                        ! uniform 
+      !
+      IF( nn_havtb == 1 ) THEN                   ! decrease avtb in the equatorial band
            !  -15S -5S : linear decrease from avt0 to avt0/10.
            !  -5S  +5N : cst value avt0/10.
